## idlestat 0.3

=== Makefile ===
#
# Makefile
#
# Copyright (C) 2014, Linaro Limited
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# Contributors:
#     Daniel Lezcano <daniel.lezcano@linaro.org>
#     Zoran Markovic <zoran.markovic@linaro.org>
#
CFLAGS?=-g -Wall
CC=gcc

OBJS = idlestat.o topology.o trace.o utils.o

default: idlestat

%.o: %.c
	$(CROSS_COMPILE)$(CC) -c -o $@ $< $(CFLAGS)

idlestat: $(OBJS)
	$(CROSS_COMPILE)$(CC) $(CFLAGS) $(OBJS) -o $@

clean:
	rm -f $(OBJS) idlestat

=== debian/changelog ===
idlestat (0.3-3) unstable; urgency=medium

  * Remove buggy memory leak on cstates fix

 -- Colin King <colin.king@canonical.com>  Thu, 21 Aug 2014 10:34:31 +0100

idlestat (0.3-2) unstable; urgency=medium

  * Fix memory leak on cstates
  * Correctly parse older versions of trace output
  * CPUs may be offline during setup, so avoid asserts
  * Correct copyright

 -- Colin King <colin.king@canonical.com>  Mon, 30 Jun 2014 21:53:22 +0100

idlestat (0.3-1) unstable; urgency=medium

  * Initial Debian release (Closes: #752158)

 -- Colin King <colin.king@canonical.com>  Thu, 26 Jun 2014 16:16:23 +0100

=== debian/control ===
Source: idlestat
Section: admin
Priority: optional
Maintainer: Colin King <colin.king@canonical.com>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 7)
Homepage: https://wiki.linaro.org/WorkingGroups/PowerManagement/Resources/Tools/Idlestat

Package: idlestat
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: measure CPU time in idle and operating states
 Idlestat uses kernel FTRACE function to monitor and capture
 C-state and P-state transitions of CPUs over a time interval.
 It calculates the total, average, min and max times spend in
 each C-state, P-state for each CPU and in each CPU cluster.
 It also reports the times specific IRQs caused the CPU to exit
 idle state, per CPU and per-IRQ.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_HARDENING=1

DESTDIR=$$(pwd)/debian/idlestat
BINDIR=/usr/bin

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); dh_auto_build

override_dh_auto_install:
	mkdir -p ${DESTDIR}${BINDIR}
	cp $$(pwd)/idlestat ${DESTDIR}${BINDIR}

%:
	dh $@

## idlestat 0.5

=== Makefile ===
--- 
+++ 
@@ -24,7 +24,16 @@
 CFLAGS?=-g -Wall
 CC=gcc
 
-OBJS = idlestat.o topology.o trace.o utils.o
+TRACE_OBJS =	tracefile_idlestat.o tracefile_ftrace.o \
+		tracefile_tracecmd.o
+REPORT_OBJS =	default_report.o csv_report.o comparison_report.o
+
+
+OBJS =	idlestat.o topology.o trace.o utils.o energy_model.o reports.o \
+	ops_head.o \
+	$(REPORT_OBJS) \
+	$(TRACE_OBJS) \
+	ops_tail.o
 
 default: idlestat

=== debian/changelog ===
idlestat (0.5-4) unstable; urgency=medium

  * initialise return status ret to 0, fixes an error found by static analysis

 -- Colin King <colin.king@canonical.com>  Wed, 9 Sep 2015 11:05:00 +0100

idlestat (0.5-3) unstable; urgency=medium

  * Fix deb5-copyright-licence-name-not-unique
  * Update debian/compat to 9
  * Reformat description in debian/control 

 -- Colin King <colin.king@canonical.com>  Sun, 16 Aug 2015 04:30:02 -0700

idlestat (0.5-2) unstable; urgency=medium

  * Topology: Fix loop bound
  * Energy model: Check for error from idlestat_load correctly
  * Energy model: Do not exit() with a negative status code
  * Utils: Add missing va_start macros
  * Idlestat: Suppress static analysis false positives
  * Idlestat: Check return value in cpuidle_get_target_residency
  * Idlestat: Fix core/cluster cstates
  * Idlestat: Add command line options for managing trace buffer
  * Idlestat: P-state calculations for cores and clusters
  * Energy_model: Don't add phony frequency to template
  * Energy_model: Add cluster P-state calculation based on trace data
  * Energy model: Make energy file parsing work for TC2
  * Energy model: Take out the wakeup energy from the energy calculation
  * Idlestat: Add energy model for arm TC2
  * Fix alignment for verbose energy model data
  * Fix P-state calculations
  * Energy model: Remove unused parameter options
  * Remove unused parameter cpu from write_cstate_info
  * Simplify event counting while loading a trace
  * Add -Wunused-parameter to CFLAGS
  * Re-enable compile and run on Android platform
  * Utils: Add missing va_end macros to verbose_(f)printf
  * Energy_model: calculate number of cap and C states correctly
  * Topology: Match cpu names only if they begin with "cpu"
  * Make read_cpu_topo_info more robust
  * Topology: Remove unused structure member
  * Handle offline cpus gracefully
  * Fix merge_pstates
  * Add idlestat manual page (LP: #1334758)

 -- Colin King <colin.king@canonical.com>  Tue, 12 May 2015 10:14:00 +0100

idlestat (0.5-1) unstable; urgency=medium

  * Re-sync to upstream version 0.5

 -- Colin King <colin.king@canonical.com>  Fri, 9 Jan 2015 18:00:00 +0100

=== debian/control ===
Source: idlestat
Section: admin
Priority: optional
Maintainer: Colin King <colin.king@canonical.com>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9)
Homepage: https://wiki.linaro.org/WorkingGroups/PowerManagement/Resources/Tools/Idlestat

Package: idlestat
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: measure CPU time in idle and operating states
 Idlestat uses kernel FTRACE function to monitor and capture C-state and
 P-state transitions of CPUs over a time interval.  It calculates the total,
 average, min and max times spend in each C-state, P-state for each CPU and in
 each CPU cluster.  It also reports the times specific IRQs caused the CPU
 to exit idle state, per CPU and per-IRQ.

## idlestat 0.6

=== debian/changelog ===
idlestat (0.6-2) unstable; urgency=medium

  * Fix various minor fixes found with static analysis, patches
    waiting to land upstream
    - Replace deprecated readdir_r with readdir
    - topology: remove check for same cpuid cannot exist in different cores
    - fix memory leak in cpuidle_get_target_residency, free fpath
    - fix TRACE_IPIIRQ_FORMAT string format width overflow scan issue
    - Use %zu format specifier for size_t types

 -- Colin King <colin.king@canonical.com>  Wed, 31 Aug 2016 10:22:42 +0100

idlestat (0.6-1) unstable; urgency=medium

  * Sync with 0.6 upstream release
  * Remove debian patches that are now in 0.6 release
  * Update Standards-Version to 3.9.8 

 -- Colin King <colin.king@canonical.com>  Wed, 31 Aug 2016 07:59:11 +0100

## idlestat 0.7

=== debian/changelog ===
idlestat (0.7-2) unstable; urgency=medium

  [ Lisa Nguyen ]
  * Pull in 3 upstream changes:
    - Update documentation for idlestat
    - Fix resource leak in output_cstate_info() and build_cstate_info()
    - Fix resource leak in energy_model.c

 -- Colin King <colin.king@canonical.com>  Fri, 9 Dec 2016 11:03:02 +0000

idlestat (0.7-1) unstable; urgency=medium

  * Sync with 0.7 upstream release (Closes: #839891)
  * Remove debian patches that are now in 0.7 release

 -- Colin King <colin.king@canonical.com>  Thu, 6 Oct 2016 9:24:52 +0100

## idlestat 0.8

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 #     Daniel Lezcano <daniel.lezcano@linaro.org>
 #     Zoran Markovic <zoran.markovic@linaro.org>
 #
-CFLAGS?=-g -Wall
+CFLAGS?=-g -Wall -Wunused-parameter
 CC=gcc
 
 TRACE_OBJS =	tracefile_idlestat.o tracefile_ftrace.o \
@@ -43,5 +43,9 @@
 idlestat: $(OBJS)
 	$(CROSS_COMPILE)$(CC) $(CFLAGS) $(OBJS) -o $@
 
+install: idlestat idlestat.1
+	install -D -t /usr/local/bin idlestat
+	install -D -t /usr/local/man/man1 idlestat.1
+
 clean:
 	rm -f $(OBJS) idlestat

=== debian/changelog ===
idlestat (0.8-9) unstable; urgency=medium

  * Orphan upload
  * Update Maintainer field to Debian QA Group <packages@qa.debian.org>
    so package can be orphaned
  * Update standards-version to 4.7.2

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 15 Sep 2025 17:45:42 +0100

idlestat (0.8-8) unstable; urgency=medium

  * debian/copyright: update copyright year
  * debian/rules: improve hardening rules
  * debian/rules: remove some debug echo statements

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 12 Jan 2024 12:53:57 +0000

idlestat (0.8-7) unstable; urgency=medium

  * debian/copyright: update copyright year
  * debian/control: update standands version to 4.6.2
  * Fix fails to build source after successful build (Closes: #1048473)

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 14 Aug 2023 09:39:21 +0100

idlestat (0.8-6) unstable; urgency=medium

  * Debian/control: update standards version to 4.6.1
  * Debian/control: update maintainer email address
  * Debian/copyright: fix trace.h pattern in copyright file pattern
  * Add EOF check on a fgets calls
    patches/0006-tracefile_tracecmd-add-null-return-from-fgets-when-E.patch
    patches/0007-tracefile_idlestat-EOF-checks-while-parsing-file-wit.patch

 -- Colin Ian King <colin.i.king@gmail.com>  Tue, 13 Dec 2022 16:38:47 +0000

idlestat (0.8-5) unstable; urgency=medium

  * Debian/control: update Homepage URL (Closes: #984435)

 -- Colin King <colin.king@canonical.com>  Wed, 3 Mar 2021 18:29:52 +0000

idlestat (0.8-4) unstable; urgency=medium

  * Debian/control: update compat to 13, remove compat file
  * Debian/control: add Rules-Requires-Root

 -- Colin King <colin.king@canonical.com>  Sat, 4 Jul 2020 15:30:22 +0100

idlestat (0.8-3) unstable; urgency=medium

  * Pull in some fixes to issues found with static analysis:
    - comparison_report: fix diff.late_wakings calculation,
      late_wakings calculation is always zero because of a typo, fix
      this.
    - csv_report: print unsigned int using %u specifier instead of %d
    - energy_model: print and scan unsigned ints using %u
    - idlestat: fix -t with negative values
    - idlestat: fix number of cpus check
  * Remove empty line from debian/control

 -- Colin King <colin.king@canonical.com>  Sun, 21 Jul 2019 18:16:14 +1000

idlestat (0.8-2) unstable; urgency=medium

  * Update Standards-Version to 11
  * Fix Lintian warning on dep5 copyright ordering
  * Remove a couple of trailing whitespaces from buildlog
  * Fix nsecure-copyright-format-uri in copyright file

 -- Colin King <colin.king@canonical.com>  Tue, 6 Mar 2018 03:37:13 +0000

idlestat (0.8-1) unstable; urgency=medium

  * Sync with 0.8 upstream release
  * Remove debian patches that are now in 0.8 release

 -- Colin King <colin.king@canonical.com>  Mon, 24 Apr 2017 13:59:41 +0100

=== debian/control ===
Source: idlestat
Rules-Requires-Root: no
Section: admin
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 4.7.2
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13)
Homepage: https://wiki-archive.linaro.org/WorkingGroups/PowerManagement/Resources/Tools/Idlestat

Package: idlestat
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: measure CPU time in idle and operating states
 Idlestat uses kernel FTRACE function to monitor and capture C-state and
 P-state transitions of CPUs over a time interval.  It calculates the total,
 average, min and max times spend in each C-state, P-state for each CPU and in
 each CPU cluster.  It also reports the times specific IRQs caused the CPU
 to exit idle state, per CPU and per-IRQ.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DESTDIR=$$(pwd)/debian/idlestat
BINDIR=/usr/bin
MANDIR=/usr/share/man/man1

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); dh_auto_build

override_dh_auto_install:
	mkdir -p ${DESTDIR}${BINDIR}
	cp $$(pwd)/idlestat ${DESTDIR}${BINDIR}
	mkdir -p ${DESTDIR}${MANDIR}
	gzip -c $$(pwd)/idlestat.1 > $$(pwd)/idlestat.1.gz
	cp $$(pwd)/idlestat.1.gz ${DESTDIR}${MANDIR}

%:
	dh $@
